//
//  ViewController.m
//  QuckRearrangeTableView Example
//
//  Created by swante on 26.07.13.
//  Copyright (c) 2013 Sergey Pershenkov. All rights reserved.
//

#import "ViewController.h"

@implementation ViewController
{
  NSMutableArray *dataObjects_;
}

- (void)viewDidLoad
{
  [super viewDidLoad];
  
  self.tableView.catchWithoutSeparator = NO;
  
  self.tableView.cellsAreMutable = YES;
  
  dataObjects_ = [NSMutableArray arrayWithObjects:@"Object A", @"Object B", @"Object C", @"Object D", @"Object E", nil];
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
  return dataObjects_.count;
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
  UITableViewCell *cell = [[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:nil];
  
  if([dataObjects_[indexPath.row] isEqualToString:@"dummy"])
  {
    cell.contentView.backgroundColor = [UIColor lightGrayColor];
  }
  else
  {
    cell.textLabel.text = dataObjects_[indexPath.row];
    
    cell.detailTextLabel.text = [NSString stringWithFormat:@"Row %d", indexPath.row];
  }
  
  return cell;
}

- (id)getObjectFromIndexPath:(NSIndexPath *)indexPath
{
  id object = dataObjects_[indexPath.row];
  
  [dataObjects_ replaceObjectAtIndex:indexPath.row withObject:@"dummy"];
  
  return object;
}

- (void)moveRowFromIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
  id object = dataObjects_[fromIndexPath.row];
  
  [dataObjects_ removeObjectAtIndex:fromIndexPath.row];
  
  [dataObjects_ insertObject:object atIndex:toIndexPath.row];
}

- (void)setObject:(id)object atIndexPath:(NSIndexPath *)indexPath
{
  [dataObjects_ replaceObjectAtIndex:indexPath.row withObject:object];
}

- (void)viewDidUnload
{
  [self setTableView:nil];
  
  [super viewDidUnload];
}

@end
