//
//  QuickRearrangeTableView.h
//  QuickRearrangeTableView
//
//  Created by Sergey Pershenkov on 5/2/13.
//  Copyright (c) 2013 Sergey Pershenkov. All rights reserved.
//

@protocol QuickRearrangeTableViewDelegate <UITableViewDelegate>

// Must return object at index indexPath.row from table datasource and replace it by @"dummy"
- (id)getObjectFromIndexPath:(NSIndexPath *)indexPath;

// Must remove object at index fromIndexPath.row from table datasource and insert it at index toIndexPath.row
- (void)moveRowFromIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath;

// Must replace object at index indexPath.row from table datasource with (id)object
- (void)setObject:(id)object atIndexPath:(NSIndexPath *)indexPath;

@end

@interface QuickRearrangeTableView : UITableView

@property (nonatomic, assign) id <QuickRearrangeTableViewDelegate> delegate;

// Cells will be refreshed after rearrange
@property (nonatomic) BOOL cellsAreMutable;

// Cell will be catched without bottom pixels
@property (nonatomic) BOOL catchWithoutSeparator;

- (void)longPress:(UILongPressGestureRecognizer *)gestureRecognizer;
- (void)moveDummyRow:(UILongPressGestureRecognizer *)gestureRecognizer;
- (void)scrollTableView:(NSTimer *)timer;
- (void)finishRearrange;
- (void)appBecomeActive;

@end
